﻿#include "osecpu.h"
#include "jitc.h"

//
// JITC common functions (architecture not dependent)
//

void errorHandler(HOSECPU_RuntimeEnvironment *r)
{
	puts("security error! abort...");
	printf("debugInfo0=%d, debugInfo1=%d\n", r->debugInfo0, r->debugInfo1);
#if	(ENABLE_DEBUG_CODE != 0)
	printf("Last opcode may be 0x%02X (Backend).\n", r->dbg_currentCode);
#endif
	
#if	(ENABLE_DEBUG_CODE_ADDR != 0)
	printf("At backend code bin +0x%04X.\n", r->dbg_currentCodeAddress);
#endif
	
#if (USE_DEBUGGER != 0)
	dbgrMain(r);
#endif
	exit(1);
}

int jitCompCmdLen(const unsigned char *src)
{
	//BCode命令長を取得する
	int i = 1;
	
	if (0x01 <= *src && *src < 0x04){
		// LB, LIMM, PLIMM
		i = 6;
	} else if (*src == 0x04){
		// CND
		i = 2;
	} else if (0x08 <= *src && *src < 0x0d){
		// LMEM, SMEM, ??, ??, ??
		i = 8 + src[7] * 4;
	} else if (0x0e <= *src && *src < 0x10){
		// PADD, PDIF
		i = 8;
	} else if (0x10 <= *src && *src < 0x1c){
		// CP/OR, XOR, AND, ADD, SUB, MUL, SHL, SAR, DIV, MOD,
		i = 4;
	} else if (0x1c <= *src && *src < 0x1f){
		// ??, ??, PCP
		i = 3;
	} else if (*src == 0x1f){
		// ??
		i = 11;
	} else if(0x20 <= *src && *src < 0x2e){
		// CMPE, CMPNE, CMPL, CMPGE, CMPLE, CMPG, TSTZ, TSTNZ,
		// PCMPE, PCMPNE, PCMPL, PCMPGE, PCMPLE, PCMPG,
		i = 4;
	} else if (*src == 0x2f){
		// ??
		i = 4 + src[1];
	} else if (0x30 <= *src && *src < 0x34){
		// ??, ??, MALLOC, ??
		i = 4;
	} else if (0x3c <= *src && *src < 0x3e){
		// ??, ??
		i = 7;
	} else if (*src == 0xfe){
		// REMARK
		i = 2 + src[1];
	}

	return i;
}

void PRegCopy(HOSECPU_PointerRegisterEntry *dst, HOSECPU_PointerRegisterEntry *src)
{
	// 以下の方法で代入するとMacではアライメントエラーで落ちるのです...
	// *dst = *src;
	// ということで、memcpyによる実装に変更しました。
	
	memcpy(dst, src, sizeof(HOSECPU_PointerRegisterEntry));
}




